<template>
  <div class="fr-container">
    <div class="fr-grid-row">
      <div class="fr-col-12 fr-col-lg-6">
        <BeneficiaryInfoLabel
          label="Agent(s) référent(s)"
          :value="referentNames"
        />
      </div>
      <div class="fr-col-12 fr-col-lg-6">
        <p class="fr-mb-1w">Dossier N°&nbsp;{{ beneficiary.fileNumber }}</p>
        <div class="fr-mb-1w">
          <BeneficiaryDetailsStatus :status="beneficiary.status" />
        </div>
        <div v-if="beneficiary.aidantConnectAuthorized">
          <div class="fr-icon-success-line field-value">
            Mandat Aidants Connect
          </div>
        </div>
        <div
          v-if="
            application.module.vulnerablePerson && beneficiary.vulnerablePerson
          "
          :class="{ 'fr-mt-3v': beneficiary.aidantConnectAuthorized }"
        >
          <div class="fr-icon-success-line field-value">
            Registre des personnes vulnérables
          </div>
        </div>
      </div>
    </div>

    <template v-if="hasCoordinatesInformations(beneficiary.general)">
      <hr class="fr-col-12 fr-mt-5v fr-no-print" />

      <div class="fr-grid-row">
        <div class="fr-col-12">
          <div class="fr-pb-2w fr-text--bold">Coordonnées du bénéficiaire</div>
        </div>
      </div>
      <div class="fr-grid-row">
        <div
          v-if="hasPhoneOrAddress(beneficiary.general)"
          class="fr-col-6"
        >
          <BeneficiaryInfoLabel
            label="Numéro de téléphone"
            :value="phoneLabel"
          />
          <BeneficiaryInfoLabel
            label="Adresse"
            :value="formatAddress(beneficiary.general)"
          />
          <BeneficiaryInfoLabel
            v-if="beneficiary.general.qpv != null"
            :label="beneficiaryFieldLabels.qpv"
            :value="beneficiary.general.qpv ? 'Oui' : 'Non'"
          />
        </div>
        <div
          v-if="hasEmailOrAddressComplement(beneficiary.general)"
          class="fr-col-6"
        >
          <BeneficiaryInfoLabel
            label="Email"
            :value="beneficiary.general.email"
          />
          <BeneficiaryInfoLabel
            label="Complément d'adresse"
            :value="beneficiary.general.addressComplement"
          />
        </div>
      </div>
    </template>
  </div>
</template>

<script lang="ts" setup>
  import type { GetBeneficiaryOutput } from '~/types/beneficiary'
  import { formatUserDisplayName } from '~/utils/user'
  import {
    formatAddress,
    hasCoordinatesInformations,
    hasPhoneOrAddress,
    hasEmailOrAddressComplement
  } from '~/utils/beneficiary'
  import { beneficiaryFieldLabels } from '~/client/labels/beneficiary.labels'

  const props = defineProps<{
    beneficiary: GetBeneficiaryOutput
  }>()

  const { application } = usePermissions()

  const referentNames = computed(() =>
    props.beneficiary.referents
      .map(referent => formatUserDisplayName(referent))
      .join(', ')
  )

  const phoneLabel = computed(() => {
    if (props.beneficiary.general.noPhone) {
      return "N'a pas de téléphone"
    }
    if (props.beneficiary.general.phone1) {
      const phones = [props.beneficiary.general.phone1]
      if (props.beneficiary.general.phone2) {
        phones.push(props.beneficiary.general.phone2)
      }
      return phones.join(', ')
    }
    return undefined
  })
</script>

<style scoped>
  .beneficiaryinfoheader__section {
    display: flex;
    flex-direction: column;
    justify-content: center;
  }
</style>
